function ConstructODEIntegrator(oModel)

% IM : reactants matrix
% OM : products matrix
mIn = oModel.mReactants;
mOut = oModel.mProducts;


% 
% s=what;
% CurrentPath=s.path;

% s.path=oModel.path;
%eval(sprintf('Mfile = fopen(''%sODEIntegrator.m'')',oModel.tModelName));

%if Mfile==-1
    
% create the required file
    eval(sprintf('Mfile = fopen(''%s\\%sODEIntegrator.m'',''w'');',oModel.path,oModel.tModelName));
    
    fprintf(Mfile,'function [T,X] = %sODEIntegrator(vTimeRange, vk, vX0, options)\n\n',oModel.tModelName);
    fprintf(Mfile,'if nargin<3 || length(vk)~=%i || length(vX0)~=%i || length(vTimeRange)>2',oModel.slk,oModel.slX);
    fprintf(Mfile,'\n\tT=0;X=0;\n\tdisp(''Incorrect arguments'')\n\treturn\nend\n\n');
    
    
    % writing the differential equations
    fprintf(Mfile,'function dX = F(t,X)\n');
    fprintf(Mfile,'\tdX = X;\n');
    
    for i=1:oModel.slX
        fprintf(Mfile,'\tdX(%i) = 0',i);
        for j=1:oModel.slk
            if (mOut(j,i)-mIn(j,i))~=0
                fprintf(Mfile,' %+i*vk(%i)',(mOut(j,i)-mIn(j,i)),j);
                for l=1:oModel.slX
                    if mIn(j,l)==1
                        fprintf(Mfile,'*X(%i)',l);
                    elseif mIn(j,l)>=2
                        fprintf(Mfile,'*X(%i)^(%i)',l,mIn(j,l));
                    end
                end
            end
        end
        fprintf(Mfile,';\n');
    end
    fprintf(Mfile,'end\n\n');
    
    fprintf(Mfile,'if length(vTimeRange)==1 \n\t');
    fprintf(Mfile,'X=F(vTimeRange,vX0);\n\tT=vTimeRange;\n\treturn\n');
    fprintf(Mfile,'elseif exist(''options'')\n\t');
    fprintf(Mfile,'[T,X]=%s(@F,vTimeRange,vX0,options);\n',oModel.tODEFunction);
    fprintf(Mfile,'else\n\t');
    fprintf(Mfile,'[T,X]=%s(@F,vTimeRange,vX0);\n',oModel.tODEFunction);
    fprintf(Mfile,'end\n\ni=1;\n');
    fprintf(Mfile,'while i<min(vTimeRange)\n');
    fprintf(Mfile,'\ti=i+1;\nend\n');
    fprintf(Mfile,'T=T(i:end);\nX=X(i:end,:);\n\nend\n');
    
%end
    

fclose(Mfile);

