function standard_graph(h)

% standard_graph(h)
%   set the standard formating for a plot
%   h should be a handle structure:
%       h.fig           handle to the figure
%       h.sub{i}.f      handle to the plot or subplots (with cell)
%       h.sub{i}.xl     handle to the xlabel of subplot i
%       h.sub{i}.yl     handle to the ylabel of subplot i
%
% Version 1, october 2008
% Marc Hafner, EPFL-IC-LANOS, Switzerland
% help and comments to marc.hafner@epfl.ch
%


if isstruct(h)
    lh = length(h.sub);
    for i=1:lh
        set(h.sub{i}.f,'fontsize',15,'fontweight','bold','XMinorTick','on', 'YMinorTick','on');

        if ~isempty(h.sub{i}.xl)
            set(h.sub{i}.xl, 'fontsize',18,'fontweight','demi');
        end
        if ~isempty(h.sub{i}.yl)
            set(h.sub{i}.yl, 'fontsize',18,'fontweight','demi');
        end
    end
    

    nbplotlines = ceil(lh/4);
    nbplotcol = ceil(lh/nbplotlines);

    if nbplotcol~=1
        set(gcf,  'Position',[20, 20, nbplotcol*420, nbplotlines*520],  'PaperUnits','points', 'Papersize', ones(1,2)*max([nbplotlines*520 nbplotcol*420 ]), 'PaperPosition',[0, 0, nbplotcol*420, nbplotlines*520])
    else
        nbplotcol = 2;
        set(gcf,  'Position',[20, 20, nbplotcol*420, nbplotlines*520],  'PaperUnits','points', 'Papersize', ones(1,2)*max([nbplotlines*520 nbplotcol*420 ]), 'PaperPosition',[0, 0, nbplotcol*420, nbplotlines*520])        
    end
     
elseif ishandle(h)
    set(h,'fontsize',14,'fontweight','bold');
end